QCPFinancial Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Types | Public Functions | Static Public Functions | Protected Functions
QCPFinancial Class Reference

A plottable representing a financial stock chart. More...

Inheritance diagram for QCPFinancial:

## Public Types
enum | WidthType
enum | ChartStyle

## Public Functions
| QCPFinancial (QCPAxis *keyAxis, QCPAxis *valueAxis)
QSharedPointer< QCPFinancialDataContainer > | data () const
ChartStyle | chartStyle () const
double | width () const
WidthType | widthType () const
bool | twoColored () const
QBrush | brushPositive () const
QBrush | brushNegative () const
QPen | penPositive () const
QPen | penNegative () const
void | setData (QSharedPointer< QCPFinancialDataContainer > data)
void | setData (const QVector< double > &keys, const QVector< double > &open, const QVector< double > &high, const QVector< double > &low, const QVector< double > &close, bool alreadySorted=false)
void | setChartStyle (ChartStyle style)
void | setWidth (double width)
void | setWidthType (WidthType widthType)
void | setTwoColored (bool twoColored)
void | setBrushPositive (const QBrush &brush)
void | setBrushNegative (const QBrush &brush)
void | setPenPositive (const QPen &pen)
void | setPenNegative (const QPen &pen)
void | addData (const QVector< double > &keys, const QVector< double > &open, const QVector< double > &high, const QVector< double > &low, const QVector< double > &close, bool alreadySorted=false)
void | addData (double key, double open, double high, double low, double close)
virtual QCPDataSelection | selectTestRect (const QRectF &rect, bool onlySelectable) const
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=nullptr) const
virtual QCPRange | getKeyRange (bool &foundRange, QCP::SignDomain inSignDomain=QCP::sdBoth) const
virtual QCPRange | getValueRange (bool &foundRange, QCP::SignDomain inSignDomain=QCP::sdBoth, const QCPRange &inKeyRange=QCPRange()) const
Public Functions inherited from QCPAbstractPlottable1D< QCPFinancialData >
| QCPAbstractPlottable1D (QCPAxis *keyAxis, QCPAxis *valueAxis)
virtual int | dataCount () const
virtual double | dataMainKey (int index) const
virtual double | dataSortKey (int index) const
virtual double | dataMainValue (int index) const
virtual QCPRange | dataValueRange (int index) const
virtual QPointF | dataPixelPosition (int index) const
virtual bool | sortKeyIsMainKey () const
virtual QCPDataSelection | selectTestRect (const QRectF &rect, bool onlySelectable) const
virtual int | findBegin (double sortKey, bool expandedRange=true) const
virtual int | findEnd (double sortKey, bool expandedRange=true) const
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=nullptr) const
virtual QCPPlottableInterface1D * | interface1D ()
Public Functions inherited from QCPAbstractPlottable
| QCPAbstractPlottable (QCPAxis *keyAxis, QCPAxis *valueAxis)
QString | name () const
bool | antialiasedFill () const
bool | antialiasedScatters () const
QPen | pen () const
QBrush | brush () const
QCPAxis * | keyAxis () const
QCPAxis * | valueAxis () const
QCP::SelectionType | selectable () const
bool | selected () const
QCPDataSelection | selection () const
QCPSelectionDecorator * | selectionDecorator () const
void | setName (const QString &name)
void | setAntialiasedFill (bool enabled)
void | setAntialiasedScatters (bool enabled)
void | setPen (const QPen &pen)
void | setBrush (const QBrush &brush)
void | setKeyAxis (QCPAxis *axis)
void | setValueAxis (QCPAxis *axis)
Q_SLOT void | setSelectable (QCP::SelectionType selectable)
Q_SLOT void | setSelection (QCPDataSelection selection)
void | setSelectionDecorator (QCPSelectionDecorator *decorator)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=nullptr) const =0
virtual QCPPlottableInterface1D * | interface1D ()
virtual QCPRange | getKeyRange (bool &foundRange, QCP::SignDomain inSignDomain=QCP::sdBoth) const =0
virtual QCPRange | getValueRange (bool &foundRange, QCP::SignDomain inSignDomain=QCP::sdBoth, const QCPRange &inKeyRange=QCPRange()) const =0
void | coordsToPixels (double key, double value, double &x, double &y) const
const QPointF | coordsToPixels (double key, double value) const
void | pixelsToCoords (double x, double y, double &key, double &value) const
void | pixelsToCoords (const QPointF &pixelPos, double &key, double &value) const
void | rescaleAxes (bool onlyEnlarge=false) const
void | rescaleKeyAxis (bool onlyEnlarge=false) const
void | rescaleValueAxis (bool onlyEnlarge=false, bool inKeyRange=false) const
bool | addToLegend (QCPLegend *legend)
bool | addToLegend ()
bool | removeFromLegend (QCPLegend *legend) const
bool | removeFromLegend () const
Public Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=nullptr)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=nullptr) const
bool | realVisibility () const
virtual int | dataCount () const =0
virtual double | dataMainKey (int index) const =0
virtual double | dataSortKey (int index) const =0
virtual double | dataMainValue (int index) const =0
virtual QCPRange | dataValueRange (int index) const =0
virtual QPointF | dataPixelPosition (int index) const =0
virtual bool | sortKeyIsMainKey () const =0
virtual QCPDataSelection | selectTestRect (const QRectF &rect, bool onlySelectable) const =0
virtual int | findBegin (double sortKey, bool expandedRange=true) const =0
virtual int | findEnd (double sortKey, bool expandedRange=true) const =0

## Static Public Functions
static QCPFinancialDataContainer | timeSeriesToOhlc (const QVector< double > &time, const QVector< double > &value, double timeBinSize, double timeBinOffset=0)

## Protected Functions
virtual void | draw (QCPPainter *painter)
virtual void | drawLegendIcon (QCPPainter *painter, const QRectF &rect) const
void | drawOhlcPlot (QCPPainter *painter, const QCPFinancialDataContainer::const_iterator &begin, const QCPFinancialDataContainer::const_iterator &end, bool isSelected)
void | drawCandlestickPlot (QCPPainter *painter, const QCPFinancialDataContainer::const_iterator &begin, const QCPFinancialDataContainer::const_iterator &end, bool isSelected)
double | getPixelWidth (double key, double keyPixel) const
double | ohlcSelectTest (const QPointF &pos, const QCPFinancialDataContainer::const_iterator &begin, const QCPFinancialDataContainer::const_iterator &end, QCPFinancialDataContainer::const_iterator &closestDataPoint) const
double | candlestickSelectTest (const QPointF &pos, const QCPFinancialDataContainer::const_iterator &begin, const QCPFinancialDataContainer::const_iterator &end, QCPFinancialDataContainer::const_iterator &closestDataPoint) const
void | getVisibleDataBounds (QCPFinancialDataContainer::const_iterator &begin, QCPFinancialDataContainer::const_iterator &end) const
QRectF | selectionHitBox (QCPFinancialDataContainer::const_iterator it) const
Protected Functions inherited from QCPAbstractPlottable1D< QCPFinancialData >
void | getDataSegments (QList< QCPDataRange > &selectedSegments, QList< QCPDataRange > &unselectedSegments) const
void | drawPolyline (QCPPainter *painter, const QVector< QPointF > &lineData) const
Protected Functions inherited from QCPAbstractPlottable
virtual QRect | clipRect () const
virtual void | draw (QCPPainter *painter)=0
virtual QCP::Interaction | selectionCategory () const
void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
virtual void | drawLegendIcon (QCPPainter *painter, const QRectF &rect) const =0
void | applyFillAntialiasingHint (QCPPainter *painter) const
void | applyScattersAntialiasingHint (QCPPainter *painter) const
Protected Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
virtual QCP::Interaction | selectionCategory () const
virtual QRect | clipRect () const
virtual void | applyDefaultAntialiasingHint (QCPPainter *painter) const =0
virtual void | draw (QCPPainter *painter)=0
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
virtual void | mousePressEvent (QMouseEvent *event, const QVariant &details)
virtual void | mouseMoveEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseReleaseEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseDoubleClickEvent (QMouseEvent *event, const QVariant &details)
virtual void | wheelEvent (QWheelEvent *event)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Additional Inherited Members
Signals inherited from QCPAbstractPlottable
void | selectionChanged (bool selected)
void | selectionChanged (const QCPDataSelection &selection)
void | selectableChanged (QCP::SelectionType selectable)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)

## Detailed Description

A plottable representing a financial stock chart.

This plottable represents time series data binned to certain intervals, mainly used for stock charts. The two common representations OHLC (Open-High-Low-Close) bars and Candlesticks can be set via setChartStyle.

The data is passed via setData as a set of open/high/low/close values at certain keys (typically times). This means the data must be already binned appropriately. If data is only available as a series of values (e.g. price against time), you can use the static convenience function timeSeriesToOhlc to generate binned OHLC-data which can then be passed to setData.

The width of the OHLC bars/candlesticks can be controlled with setWidth and setWidthType. A typical choice is to set the width type to wtPlotCoords (the default) and the width to (or slightly less than) one time bin interval width.

# Changing the appearance

Charts can be either single- or two-colored (setTwoColored). If set to be single-colored, lines are drawn with the plottable's pen (setPen) and fills with the brush (setBrush).

If set to two-colored, positive changes of the value during an interval (close >= open) are represented with a different pen and brush than negative changes (close < open). These can be configured with setPenPositive, setPenNegative, setBrushPositive, and setBrushNegative. In two-colored mode, the normal plottable pen/brush is ignored. Upon selection however, the normal selected pen/brush (provided by the selectionDecorator) is used, irrespective of whether the chart is single- or two-colored.

# Usage

Like all data representing objects in QCustomPlot, the QCPFinancial is a plottable (QCPAbstractPlottable). So the plottable-interface of QCustomPlot applies (QCustomPlot::plottable, QCustomPlot::removePlottable, etc.)

Usually, you first create an instance:

QCPFinancial *newFinancial = new QCPFinancial(customPlot->xAxis, customPlot->yAxis);
QCPFinancial
A plottable representing a financial stock chart.
Definition: plottable-financial.h:70

which registers it with the QCustomPlot instance of the passed axes. Note that this QCustomPlot instance takes ownership of the plottable, so do not delete it manually but use QCustomPlot::removePlottable() instead. The newly created plottable can be modified, e.g.:

newFinancial->setName("Stock prices");
newFinancial->data()->set(QCPFinancial::timeSeriesToOhlc(time, price, 3600*24));
newFinancial->setChartStyle(QCPFinancial::csCandlestick);
QCPAbstractPlottable::setName
void setName(const QString &name)
Definition: plottable.cpp:459
QCPFinancial::csCandlestick
@ csCandlestick
Candlestick representation.
Definition: plottable-financial.h:101
QCPFinancial::setChartStyle
void setChartStyle(ChartStyle style)
Definition: plottable-financial.cpp:264
QCPFinancial::timeSeriesToOhlc
static QCPFinancialDataContainer timeSeriesToOhlc(const QVector< double > &time, const QVector< double > &value, double timeBinSize, double timeBinOffset=0)
Definition: plottable-financial.cpp:513
QCPFinancial::data
QSharedPointer< QCPFinancialDataContainer > data() const
Definition: plottable-financial.h:109

Here we have used the static helper method timeSeriesToOhlc, to turn a time-price data series into a 24-hour binned open-high-low-close data series as QCPFinancial uses.

## Member Enumeration Documentation

## ◆ WidthType

enum QCPFinancial::WidthType

Defines the ways the width of the financial bar can be specified. Thus it defines what the number passed to setWidth actually means.

See also
  setWidthType, setWidth

Enumerator
wtAbsolute | width is in absolute pixels
wtAxisRectRatio | width is given by a fraction of the axis rect size
wtPlotCoords | width is in key coordinates and thus scales with the key axis range

## ◆ ChartStyle

enum QCPFinancial::ChartStyle

Defines the possible representations of OHLC data in the plot.

See also
  setChartStyle

Enumerator
csOhlc | Open-High-Low-Close bar representation.
csCandlestick | Candlestick representation.

## Constructor & Destructor Documentation

## ◆ QCPFinancial()

QCPFinancial::QCPFinancial | ( | QCPAxis * | keyAxis,
|  | QCPAxis * | valueAxis
| ) |  |
| explicit

Constructs a financial chart which uses keyAxis as its key axis ("x") and valueAxis as its value axis ("y"). keyAxis and valueAxis must reside in the same QCustomPlot instance and not have the same orientation. If either of these restrictions is violated, a corresponding message is printed to the debug output (qDebug), the construction is not aborted, though.

The created QCPFinancial is automatically registered with the QCustomPlot instance inferred from keyAxis. This QCustomPlot instance takes ownership of the QCPFinancial, so do not delete it manually but use QCustomPlot::removePlottable() instead.

## Member Function Documentation

## ◆ data()

QCPFinancialDataContainer * QCPFinancial::data | ( |  | ) | const
| inline

Returns a pointer to the internal data storage of type QCPFinancialDataContainer. You may use it to directly manipulate the data, which may be more convenient and faster than using the regular setData or addData methods, in certain situations.

## ◆ setData() [1/2]

void QCPFinancial::setData | ( | QSharedPointer< QCPFinancialDataContainer > | data | ) |

This is an overloaded function.
Replaces the current data container with the provided data container.

Since a QSharedPointer is used, multiple QCPFinancials may share the same data container safely. Modifying the data in the container will then affect all financials that share the container. Sharing can be achieved by simply exchanging the data containers wrapped in shared pointers:

financial2->setData(financial1->data()); // financial1 and financial2 now share data container

If you do not wish to share containers, but create a copy from an existing container, rather use the QCPDataContainer<DataType>::set method on the financial's data container directly:

financial2->data()->set(*financial1->data()); // financial2 now has copy of financial1's data in its container

See also
  addData, timeSeriesToOhlc

## ◆ setData() [2/2]

void QCPFinancial::setData | ( | const QVector< double > & | keys,
|  | const QVector< double > & | open,
|  | const QVector< double > & | high,
|  | const QVector< double > & | low,
|  | const QVector< double > & | close,
|  | bool | alreadySorted = `false`
| ) |  |

This is an overloaded function.
Replaces the current data with the provided points in keys, open, high, low and close. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

If you can guarantee that the passed data points are sorted by keys in ascending order, you can set alreadySorted to true, to improve performance by saving a sorting run.

See also
  addData, timeSeriesToOhlc

## ◆ setChartStyle()

void QCPFinancial::setChartStyle | ( | QCPFinancial::ChartStyle | style | ) |

Sets which representation style shall be used to display the OHLC data.

## ◆ setWidth()

void QCPFinancial::setWidth | ( | double | width | ) |

Sets the width of the individual bars/candlesticks to width in plot key coordinates.

A typical choice is to set it to (or slightly less than) one bin interval width.

## ◆ setWidthType()

void QCPFinancial::setWidthType | ( | QCPFinancial::WidthType | widthType | ) |

Sets how the width of the financial bars is defined. See the documentation of WidthType for an explanation of the possible values for widthType.

The default value is wtPlotCoords.

See also
  setWidth

## ◆ setTwoColored()

void QCPFinancial::setTwoColored | ( | bool | twoColored | ) |

Sets whether this chart shall contrast positive from negative trends per data point by using two separate colors to draw the respective bars/candlesticks.

If twoColored is false, the normal plottable's pen and brush are used (setPen, setBrush).

See also
  setPenPositive, setPenNegative, setBrushPositive, setBrushNegative

## ◆ setBrushPositive()

void QCPFinancial::setBrushPositive | ( | const QBrush & | brush | ) |

If setTwoColored is set to true, this function controls the brush that is used to draw fills of data points with a positive trend (i.e. bars/candlesticks with close >= open).

If twoColored is false, the normal plottable's pen and brush are used (setPen, setBrush).

See also
  setBrushNegative, setPenPositive, setPenNegative

## ◆ setBrushNegative()

void QCPFinancial::setBrushNegative | ( | const QBrush & | brush | ) |

If setTwoColored is set to true, this function controls the brush that is used to draw fills of data points with a negative trend (i.e. bars/candlesticks with close < open).

If twoColored is false, the normal plottable's pen and brush are used (setPen, setBrush).

See also
  setBrushPositive, setPenNegative, setPenPositive

## ◆ setPenPositive()

void QCPFinancial::setPenPositive | ( | const QPen & | pen | ) |

If setTwoColored is set to true, this function controls the pen that is used to draw outlines of data points with a positive trend (i.e. bars/candlesticks with close >= open).

If twoColored is false, the normal plottable's pen and brush are used (setPen, setBrush).

See also
  setPenNegative, setBrushPositive, setBrushNegative

## ◆ setPenNegative()

void QCPFinancial::setPenNegative | ( | const QPen & | pen | ) |

If setTwoColored is set to true, this function controls the pen that is used to draw outlines of data points with a negative trend (i.e. bars/candlesticks with close < open).

If twoColored is false, the normal plottable's pen and brush are used (setPen, setBrush).

See also
  setPenPositive, setBrushNegative, setBrushPositive

## ◆ addData() [1/2]

void QCPFinancial::addData | ( | const QVector< double > & | keys,
|  | const QVector< double > & | open,
|  | const QVector< double > & | high,
|  | const QVector< double > & | low,
|  | const QVector< double > & | close,
|  | bool | alreadySorted = `false`
| ) |  |

This is an overloaded function.
Adds the provided points in keys, open, high, low and close to the current data. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

If you can guarantee that the passed data points are sorted by keys in ascending order, you can set alreadySorted to true, to improve performance by saving a sorting run.

Alternatively, you can also access and modify the data directly via the data method, which returns a pointer to the internal data container.

See also
  timeSeriesToOhlc

## ◆ addData() [2/2]

void QCPFinancial::addData | ( | double | key,
|  | double | open,
|  | double | high,
|  | double | low,
|  | double | close
| ) |  |

This is an overloaded function.
Adds the provided data point as key, open, high, low and close to the current data.

Alternatively, you can also access and modify the data directly via the data method, which returns a pointer to the internal data container.

See also
  timeSeriesToOhlc

## ◆ selectTestRect()

QCPDataSelection QCPFinancial::selectTestRect | ( | const QRectF & | rect,
|  | bool | onlySelectable
| ) |  | const
| virtual

Returns a data selection containing all the data points of this plottable which are contained (or hit by) rect. This is used mainly in the selection rect interaction for data selection (data selection mechanism).

If onlySelectable is true, an empty QCPDataSelection is returned if this plottable is not selectable (i.e. if QCPAbstractPlottable::setSelectable is QCP::stNone).

Note
  rect must be a normalized rect (positive or zero width and height). This is especially important when using the rect of QCPSelectionRect::accepted, which is not necessarily normalized. Use `QRect::normalized()` when passing a rect which might not be normalized.

Reimplemented from QCPAbstractPlottable1D< QCPFinancialData >.

## ◆ selectTest()

double QCPFinancial::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `nullptr`
| ) |  | const
| virtual

Implements a selectTest specific to this plottable's point geometry.

If details is not 0, it will be set to a QCPDataSelection, describing the closest data point to pos.

For general information about this virtual method, see the base class implementation. QCPAbstractPlottable::selectTest

Reimplemented from QCPAbstractPlottable1D< QCPFinancialData >.

## ◆ getKeyRange()

QCPRange QCPFinancial::getKeyRange | ( | bool & | foundRange,
|  | QCP::SignDomain | inSignDomain = `QCP::sdBoth`
| ) |  | const
| virtual

Returns the coordinate range that all data in this plottable span in the key axis dimension. For logarithmic plots, one can set inSignDomain to either QCP::sdNegative or QCP::sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to QCP::sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to QCP::sdBoth (default). foundRange is an output parameter that indicates whether a range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

Note that foundRange is not the same as QCPRange::validRange, since the range returned by this function may have size zero (e.g. when there is only one data point). In this case foundRange would return true, but the returned range is not a valid range in terms of QCPRange::validRange.

See also
  rescaleAxes, getValueRange

Implements QCPAbstractPlottable.

## ◆ getValueRange()

QCPRange QCPFinancial::getValueRange | ( | bool & | foundRange,
|  | QCP::SignDomain | inSignDomain = `QCP::sdBoth`,
|  | const QCPRange & | inKeyRange = `QCPRange()`
| ) |  | const
| virtual

Returns the coordinate range that the data points in the specified key range (inKeyRange) span in the value axis dimension. For logarithmic plots, one can set inSignDomain to either QCP::sdNegative or QCP::sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to QCP::sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to QCP::sdBoth (default). foundRange is an output parameter that indicates whether a range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

If inKeyRange has both lower and upper bound set to zero (is equal to `QCPRange()`), all data points are considered, without any restriction on the keys.

Note that foundRange is not the same as QCPRange::validRange, since the range returned by this function may have size zero (e.g. when there is only one data point). In this case foundRange would return true, but the returned range is not a valid range in terms of QCPRange::validRange.

See also
  rescaleAxes, getKeyRange

Implements QCPAbstractPlottable.

## ◆ timeSeriesToOhlc()

QCPFinancialDataContainer QCPFinancial::timeSeriesToOhlc | ( | const QVector< double > & | time,
|  | const QVector< double > & | value,
|  | double | timeBinSize,
|  | double | timeBinOffset = `0`
| ) |  |
| static

A convenience function that converts time series data (value against time) to OHLC binned data points. The return value can then be passed on to QCPFinancialDataContainer::set(const QCPFinancialDataContainer&).

The size of the bins can be controlled with timeBinSize in the same units as time is given. For example, if the unit of time is seconds and single OHLC/Candlesticks should span an hour each, set timeBinSize to 3600.

timeBinOffset allows to control precisely at what time coordinate a bin should start. The value passed as timeBinOffset doesn't need to be in the range encompassed by the time keys. It merely defines the mathematical offset/phase of the bins that will be used to process the data.

## ◆ draw()

void QCPFinancial::draw | ( | QCPPainter * | painter | ) |
| protectedvirtual

This function draws the layerable with the specified painter. It is only called by QCustomPlot, if the layerable is visible (setVisible).

Before this function is called, the painter's antialiasing state is set via applyDefaultAntialiasingHint, see the documentation there. Further, the clipping rectangle was set to clipRect.

Implements QCPAbstractPlottable.

## ◆ drawLegendIcon()

void QCPFinancial::drawLegendIcon | ( | QCPPainter * | painter,
|  | const QRectF & | rect
| ) |  | const
| protectedvirtual

called by QCPLegend::draw (via QCPPlottableLegendItem::draw) to create a graphical representation of this plottable inside rect, next to the plottable name.

The passed painter has its cliprect set to rect, so painting outside of rect won't appear outside the legend icon border.

Implements QCPAbstractPlottable.

## ◆ drawOhlcPlot()

void QCPFinancial::drawOhlcPlot | ( | QCPPainter * | painter,
|  | const QCPFinancialDataContainer::const_iterator & | begin,
|  | const QCPFinancialDataContainer::const_iterator & | end,
|  | bool | isSelected
| ) |  |
| protected

Draws the data from begin to end-1 as OHLC bars with the provided painter.

This method is a helper function for draw. It is used when the chart style is csOhlc.

## ◆ drawCandlestickPlot()

void QCPFinancial::drawCandlestickPlot | ( | QCPPainter * | painter,
|  | const QCPFinancialDataContainer::const_iterator & | begin,
|  | const QCPFinancialDataContainer::const_iterator & | end,
|  | bool | isSelected
| ) |  |
| protected

Draws the data from begin to end-1 as Candlesticks with the provided painter.

This method is a helper function for draw. It is used when the chart style is csCandlestick.

## ◆ getPixelWidth()

double QCPFinancial::getPixelWidth | ( | double | key,
|  | double | keyPixel
| ) |  | const
| protected

This function is used to determine the width of the bar at coordinate key, according to the specified width (setWidth) and width type (setWidthType). Provide the pixel position of key in keyPixel (because usually this was already calculated via QCPAxis::coordToPixel when this function is called).

It returns the number of pixels the bar extends to higher keys, relative to the key coordinate. So with a non-reversed horizontal axis, the return value is positive. With a reversed horizontal axis, the return value is negative. This is important so the open/close flags on the csOhlc bar are drawn to the correct side.

## ◆ ohlcSelectTest()

double QCPFinancial::ohlcSelectTest | ( | const QPointF & | pos,
|  | const QCPFinancialDataContainer::const_iterator & | begin,
|  | const QCPFinancialDataContainer::const_iterator & | end,
|  | QCPFinancialDataContainer::const_iterator & | closestDataPoint
| ) |  | const
| protected

This method is a helper function for selectTest. It is used to test for selection when the chart style is csOhlc. It only tests against the data points between begin and end.

Like selectTest, this method returns the shortest distance of pos to the graphical representation of the plottable, and closestDataPoint will point to the respective data point.

## ◆ candlestickSelectTest()

double QCPFinancial::candlestickSelectTest | ( | const QPointF & | pos,
|  | const QCPFinancialDataContainer::const_iterator & | begin,
|  | const QCPFinancialDataContainer::const_iterator & | end,
|  | QCPFinancialDataContainer::const_iterator & | closestDataPoint
| ) |  | const
| protected

This method is a helper function for selectTest. It is used to test for selection when the chart style is csCandlestick. It only tests against the data points between begin and end.

Like selectTest, this method returns the shortest distance of pos to the graphical representation of the plottable, and closestDataPoint will point to the respective data point.

## ◆ getVisibleDataBounds()

void QCPFinancial::getVisibleDataBounds | ( | QCPFinancialDataContainer::const_iterator & | begin,
|  | QCPFinancialDataContainer::const_iterator & | end
| ) |  | const
| protected

called by the drawing methods to determine which data (key) range is visible at the current key axis range setting, so only that needs to be processed.

begin returns an iterator to the lowest data point that needs to be taken into account when plotting. Note that in order to get a clean plot all the way to the edge of the axis rect, begin may still be just outside the visible range.

end returns the iterator just above the highest data point that needs to be taken into account. Same as before, end may also lie just outside of the visible range

if the plottable contains no data, both begin and end point to `constEnd`.

## ◆ selectionHitBox()

QRectF QCPFinancial::selectionHitBox | ( | QCPFinancialDataContainer::const_iterator | it | ) | const
| protected

Returns the hit box in pixel coordinates that will be used for data selection with the selection rect (selectTestRect), of the data point given by it.

The documentation for this class was generated from the following files:

- src/plottables/plottable-financial.h
- src/plottables/plottable-financial.cpp